
//animation action flags

#define	ACTFLAG_JUMPTOGROUND2	0x00000800	//once "inair" note track is hit, use ground2 instead of ground
#define	ACTFLAG_OPTATTACK		0x00001000	//this is an aim--can choose to attack or not any frame.
#define	ACTFLAG_RHANDOPEN		0x00002000	//use open right hand instead of closed
#define	ACTFLAG_LHANDOPEN		0x00004000	//use open left hand instead of closed
#define ACTFLAG_BACKUP			0x00008000  //for a backwards walk.  needed for scripting
#define ACTFLAG_LEFTSTRAFE		0x00010000  //for left strafe.  needed for scripting
#define ACTFLAG_RIGHTSTRAFE		0x00020000	//for right strafe.  needed for scripting
#define ACTFLAG_FIREFROMGUN		0x00040000	//certain animations need to fire from the gun endpoint rather than the guy center (!)

//simple summary of how animation finishes--fix a few of these as specific, like endattack?????
#define ACTFLAG_FULLANIM		0x00400000  // when setting up an action, tell it to play the full animation (disallow cutting it off under normal circumstances--for pain or death it's ok)
											// use sparingly!  guys don't do much thinking while they're performing actions, so they can lose track of targets, etc. while running these anims!

#define ACTFLAG_ALWAYSPRONE		0x00800000  // means the anim is eligible to have the "shot while lying down" anim
#define ACTFLAG_MATCHANIM		0x01000000	// match relative position of similar action type (so leg position in run lines up to what it was in walk)
#define	ACTFLAG_MATCHABS		0x02000000	// match the absolute position of similar action type (for 180 turn, has a walk cycle at beginning)
#define ACTFLAG_REVERSEANIM		0x04000000
#define ACTFLAG_LOOPANIM		0x08000000

#define ACTFLAG_GRENADE			0x10000000	// Bolt on the grenade, remove when throw call is made...

#define ACTFLAG_PISS			0x20000000	// Call takeleak effect on the proper bolt-on.  Parental lockout.
#define ACTFLAG_VOMIT			0x40000000	// Call vomit effect on the proper bolt-on.  Parental lockout.

//anyone should be able to use this--not really an animation thing, just for use with the GetSequenceFor stuff
extern mmove_t	ScriptReleaseMove[];


extern mmove_t MMoves[];

extern mmove_t MDogMoves[];

extern mmove_t MCowMoves[];

//fixme: want a method of finding the best move given a list of parameters; these are too hardcoded!
//the parameters are:

//what's in each hand (body can figure this one out itself, can HOPEFULLY leave a blank spot
//						in the organization for body to fill in itself--as long as other aspects
//						of animation stay consistent no matter what's in yer hand)

//body position at start of action (body will know what position last move resulted in--works only if we can
//									assume that moves that are started always make their end positions happen)

//desired position at end of action (needs to be passed in)

//movement desired on each axis (needs to be passed in)

//basic kind of action: death, injury, attack, or none of the above (needs to be passed in)

//specific kind of action: intimidate/threaten hostage, cower in fear, aim weapon up/down/straight, 
//		specific idle, semaphore command, etc.? (needs to be passed in)

//whether monster is noticeably injured (if needed, body Could theoretically know this, though it doesn't now)

//amount/direction we want to turn (needs to be passed in)


#define default_death							MMoves[25]
#define generic_move_stand						MMoves[0]	
#define generic_move_walk						MMoves[1]	
#define generic_move_run						MMoves[2]	
#define generic_move_attack						MMoves[3]	
#define generic_move_run_gunup					MMoves[4]	
#define generic_move_death_long					MMoves[5]	
#define generic_move_jumpup_jump				MMoves[6]	
#define generic_move_attack_attitude			MMoves[7]	
#define generic_move_walk_attitude				MMoves[8]	
#define generic_move_jumpdrop					MMoves[9]	
#define generic_move_raim_p1					MMoves[10]	
#define generic_move_raim_p2					MMoves[11]	
#define generic_move_duck_down					MMoves[12]	
#define generic_move_duck_hold					MMoves[13]	
#define generic_move_duck_shoot					MMoves[14]	
#define generic_move_duck_up					MMoves[15]	
#define generic_move_standlook					MMoves[16]	
#define generic_move_standstretch				MMoves[17]	
#define	generic_move_deaththrown				MMoves[18]
#define generic_move_runscared					MMoves[19]	
#define generic_move_chaim2						MMoves[20]	
#define generic_move_staim_p2					MMoves[21]	
#define generic_move_staim_pcb					MMoves[22]	
#define generic_move_firecb						MMoves[23]
#define generic_move_death_dance				MMoves[24]	
#define generic_move_death_fallforward			MMoves[25]	
#define generic_move_attackb					MMoves[26]	
#define generic_move_death_legright				MMoves[27]	
#define generic_move_death_legleft				MMoves[28]	
#define generic_move_death_shldrright			MMoves[29]	
#define generic_move_death_shldrleft			MMoves[30]	
#define generic_move_death_backflail			MMoves[31]	
#define generic_move_death_backrtleg			MMoves[32]	
#define generic_move_death_backltleg			MMoves[33]	
#define generic_move_death_crouchshot			MMoves[34]	
#define generic_move_ashuffle_p2				MMoves[35]	
#define generic_move_ashuffle_pcb				MMoves[36]	
#define generic_move_attack_mgun				MMoves[37]	
#define generic_move_staim_ms					MMoves[38]	
#define generic_move_stand_mrs					MMoves[39]	
#define generic_move_standlook_mrs				MMoves[40]	
#define generic_move_standstretch_mrs			MMoves[41]	
#define generic_move_walk_mrs					MMoves[42]
#define generic_move_cleangun					MMoves[43]
#define generic_move_monitor_up					MMoves[44]
#define generic_move_idletalk					MMoves[45]
#define generic_move_idletalk_gest1				MMoves[46]
#define generic_move_idletalk_gest2				MMoves[47]
#define generic_move_idletalk_gest3				MMoves[48]
#define generic_move_wipebrow					MMoves[49]
#define generic_move_alarm_push					MMoves[50]
#define generic_move_yell_point					MMoves[51]
#define generic_move_yell_wave					MMoves[52]
#define generic_move_dive_toprone				MMoves[53]
#define generic_move_boom_crouch				MMoves[54]
#define generic_move_tumble_front				MMoves[55]
#define generic_move_walk_carry					MMoves[56]
#define generic_move_walk_patrol				MMoves[57]
#define generic_move_run_mrs					MMoves[58]	
#define generic_move_cfire_s					MMoves[59]	
#define generic_move_cfire_r					MMoves[60]	
#define generic_move_caim_ms					MMoves[61]	
#define generic_move_caim_r						MMoves[62]	
#define generic_move_fcornerl_m2				MMoves[63]
#define generic_move_fcornerr_m2				MMoves[64]
#define generic_move_fcornerl_p					MMoves[65]
#define generic_move_fcornerr_p					MMoves[66]
#define generic_move_walk_back_signal			MMoves[67]
#define generic_move_wturn90l_p					MMoves[68]
#define generic_move_wturn90r_p					MMoves[69]
#define generic_move_wturn90l_mrs				MMoves[70]
#define generic_move_wturn90r_mrs				MMoves[71]
#define generic_move_death_tobackrtleg			MMoves[72]	
#define generic_move_death_tobackltleg			MMoves[73]
#define generic_move_death_tobackflail			MMoves[74]	
#define generic_move_death_backrtlegdie			MMoves[75]	
#define generic_move_death_backltlegdie			MMoves[76]
#define generic_move_death_backflaildie			MMoves[77]
#define generic_move_waimstrafl_l				MMoves[78]	
#define generic_move_waimstrafr_l				MMoves[79]	
#define generic_move_wbackaim_l					MMoves[80]	
#define generic_move_walk_l						MMoves[81]	
#define generic_move_atkpause1_mrs				MMoves[82]
#define generic_move_atkpause2_mrs				MMoves[83]
#define generic_move_atkpause1_p				MMoves[84]
#define generic_move_atkpause2_p				MMoves[85]
#define generic_move_death_lbshotloop			MMoves[86]
#define generic_move_death_lbshotdeath			MMoves[87]
#define generic_move_cfire_m					MMoves[88]	
#define generic_move_wturn180_mrs				MMoves[89]	
#define generic_move_attack_sgun				MMoves[90]	
#define generic_move_opendoor					MMoves[91]	
#define generic_move_attack_rif					MMoves[92]	
#define generic_move_staim_r					MMoves[93]	
#define generic_move_duck_down_mrs				MMoves[94]	
#define generic_move_duck_up_mrs				MMoves[95]	
#define generic_move_raimstrafl_p				MMoves[96]	
#define generic_move_raimstrafr_p				MMoves[97]	
#define generic_move_raimstrafl_mrs				MMoves[98]	
#define generic_move_raimstrafr_mrs				MMoves[99]	
#define generic_move_raim_mrs					MMoves[100]	
#define generic_move_ashuffle_ms				MMoves[101]	
#define generic_move_ashuffle_r					MMoves[102]	
#define generic_move_alert_p					MMoves[103]	
#define generic_move_alertlklt_p				MMoves[104]	
#define generic_move_rollrt_p					MMoves[105]	
#define generic_move_rolllt_p					MMoves[106]	
#define generic_move_alerttrnrt_p				MMoves[107]	
#define generic_move_alert_mrs					MMoves[108]	
#define generic_move_raimstrafl_l				MMoves[109]
#define generic_move_alertlkrt_mrs				MMoves[110]	
#define generic_move_alerttrnlt_mrs				MMoves[111]	
#define generic_move_throw_gren					MMoves[112]	
#define generic_move_deadgroin					MMoves[113]	
#define generic_move_deadthroat					MMoves[114]	
#define generic_move_atksweep_mgun				MMoves[115]	
#define generic_move_idletalk_mrs				MMoves[116]
#define generic_move_idletalk_gest1_mrs			MMoves[117]
#define generic_move_idletalk_gest2_mrs			MMoves[118]
#define generic_move_idletalk_gest3_mrs			MMoves[119]
#define generic_move_praim_mrs					MMoves[120]	
#define generic_move_prfire_mrs					MMoves[121]	
#define generic_move_death_lfshotloop			MMoves[122]
#define generic_move_death_lfshotdeath			MMoves[123]
#define generic_move_cower						MMoves[124]
#define generic_move_gunshotpain				MMoves[125]
#define generic_move_jump_runfwd				MMoves[126]
#define RUBBISHWASgeneric_move_limb_jitter				MMoves[127]
#define RUBBISHWASgeneric_move_limb_jitter2				MMoves[128]
#define generic_move_rdwnstairs_p				MMoves[129]
#define generic_move_rupstairs_p				MMoves[130]
#define generic_move_death_cch_sonknees			MMoves[131]
#define generic_move_crouch_onknees				MMoves[132]
#define generic_move_turnvalve_from				MMoves[133]
#define generic_move_turnvalve					MMoves[134]
#define generic_move_turnvalve_to				MMoves[135]
#define generic_move_kicklow					MMoves[136]
#define generic_move_pistolwhip					MMoves[137]
#define generic_move_death_sinback_tofront		MMoves[138]
#define	generic_move_layside_kicked				MMoves[139]
#define generic_move_sitbywall					MMoves[140]
#define generic_move_death_tumble_toback		MMoves[141]
#define generic_move_walk_push_gate				MMoves[142]
#define generic_move_kick_door					MMoves[143]
#define generic_move_yell_at_you				MMoves[144]
#define generic_move_ileanlook_frm				MMoves[145]
#define generic_move_ileanlook_mid				MMoves[146]
#define generic_move_ileanlook_to				MMoves[147]
#define generic_move_jumpdown					MMoves[148]
#define generic_move_crouch_cower_mid			MMoves[149]
#define generic_move_crouch_cower_mid2			MMoves[150]
#define generic_move_waimstrafl_ms				MMoves[151]	
#define generic_move_waimstrafl_r				MMoves[152]	
#define generic_move_waimstrafl_p				MMoves[153]	
#define generic_move_waimstrafr_ms				MMoves[154]	
#define generic_move_waimstrafr_r				MMoves[155]	
#define generic_move_waimstrafr_p				MMoves[156]	
#define generic_move_waim_p						MMoves[157]	
#define generic_move_waim_r						MMoves[158]	
#define generic_move_waim_ms					MMoves[159]	
#define generic_move_wbackaim_p					MMoves[160]	
#define generic_move_wbackaim_r					MMoves[161]	
#define generic_move_wbackaim_ms				MMoves[162]	
#define generic_move_sunhurtfwd_p				MMoves[163]	
#define generic_move_sunhurtfwd_mrs				MMoves[164]	
#define generic_move_sunhurtbk_p				MMoves[165]	
#define generic_move_sunhurtbk_mrs				MMoves[166]	
#define generic_move_blindedto					MMoves[167]	
#define generic_move_blindedloop				MMoves[168]	
#define generic_move_blindedfrom				MMoves[169]	
#define generic_move_ishift						MMoves[170]	
#define generic_move_startled					MMoves[171]	
#define generic_move_reload_p					MMoves[172]	
#define generic_move_reload_ms					MMoves[173]	
#define generic_move_pain_rleg					MMoves[174]	
#define generic_move_pain_lleg					MMoves[175]	
#define generic_move_hop_rleg					MMoves[176]	
#define generic_move_hop_lleg					MMoves[177]	
#define generic_move_limp_rleg					MMoves[178]	
#define generic_move_limp_lleg					MMoves[179]	
#define generic_move_reload_r					MMoves[180]	
#define generic_move_crouch_cower_dwn			MMoves[181]
#define generic_move_rbackaim_mrs				MMoves[182]	
#define generic_move_rbackaim_p2				MMoves[183]	
#define generic_move_pain_rarm					MMoves[184]	
#define generic_move_pain_larm					MMoves[185]	
#define generic_move_hurt_rarm					MMoves[186]	
#define generic_move_hurt_larm					MMoves[187]
#define generic_move_dont_shoot					MMoves[188]
#define generic_move_fear_wave					MMoves[189]	
#define generic_move_rdwnstairs_mrs				MMoves[190]
#define generic_move_rupstairs_mrs				MMoves[191]
#define generic_move_hurt_aim					MMoves[192]	
#define generic_move_hurt_atk					MMoves[193]	
#define generic_move_crouch_cower_up			MMoves[194]
#define generic_move_reload_p1					MMoves[195]
#define generic_move_death_violent				MMoves[196]
#define generic_move_prcowerto					MMoves[197]
#define	generic_move_prcower					MMoves[198]
#define generic_move_death_chestfront			MMoves[199]
#define generic_move_death_gut_toside			MMoves[200]
#define generic_move_death_pulse_gun			MMoves[201]
#define generic_move_cleangun2_mrs				MMoves[202]
#define generic_move_monitor_up2				MMoves[203]
#define generic_move_touchnuts					MMoves[204]
#define generic_move_smoke_frm					MMoves[205]
#define generic_move_smoke						MMoves[206]
#define generic_move_smoke_to					MMoves[207]
#define generic_move_walk_jog_mrs				MMoves[208]
#define generic_move_walk_jog_gundwn_p			MMoves[209]
#define generic_move_walk_jog_gunup_p			MMoves[210]
#define generic_move_walk_pushcart				MMoves[211]
#define generic_move_fautosweep_pm				MMoves[212]
#define generic_move_fgangbanger_m				MMoves[213]
#define generic_move_fswatstyle_m				MMoves[214]
#define generic_move_fviolent_m					MMoves[215]
#define generic_move_fviolent_p					MMoves[216]
#define generic_move_ninjakick					MMoves[217]
#define generic_move_riflebutt					MMoves[218]
#define generic_move_death_fallfwd				MMoves[219]
#define generic_move_death_stumble_2frnt		MMoves[220]
#define generic_move_choke_stand				MMoves[221]
#define generic_move_pentium_dance				MMoves[222]
#define generic_move_go_prone					MMoves[223]
#define generic_move_ladder_down				MMoves[224]
#define generic_move_ladder_up					MMoves[225]
#define generic_move_roll_to_crouch				MMoves[226]
#define generic_move_stumble					MMoves[227]
#define generic_move_sit_idle					MMoves[228]
#define generic_move_sit_tostand				MMoves[229]
#define generic_move_prone_falling				MMoves[230]
#define generic_move_prone_falling_land			MMoves[231]
#define generic_move_prone_to_stand				MMoves[232]
#define generic_move_crouch_run_mrs				MMoves[233]
#define generic_move_crouch_run_p				MMoves[234]
#define generic_move_layback_scooch				MMoves[235]
#define generic_move_layback_die_shoot			MMoves[236]
#define generic_move_crouch_launcher_fire		MMoves[237]
#define generic_move_crouch_launcher_run_aim	MMoves[238]
#define generic_move_lob_grenade_crouch			MMoves[239]
#define generic_move_allfours_scramble			MMoves[240]
#define generic_move_prone_crawl				MMoves[241]
#define generic_move_staimup_mrs				MMoves[242]	
#define generic_move_staimup_p					MMoves[243]	
#define generic_move_staimup_l					MMoves[244]	
#define generic_move_death_onfire				MMoves[245]
#define generic_move_slash_kp_script			MMoves[246]
#define generic_move_slash_kp					MMoves[247]
#define generic_move_choketoknees				MMoves[248]
#define generic_move_chokeonkees				MMoves[249]
#define generic_move_duck_up_l					MMoves[250]	
#define generic_move_raimstrafr_l				MMoves[251]
#define generic_move_duck_down_l				MMoves[252]	
#define generic_move_rdwnstairs_l				MMoves[253]
#define generic_move_rupstairs_l				MMoves[254]
#define generic_move_raim_l						MMoves[255]	
#define generic_move_rbackaim_l					MMoves[256]	
#define generic_move_jumpstrup_jump_l			MMoves[257]	
#define generic_move_waim_l						MMoves[258]	
#define generic_move_reload_l					MMoves[259]	
#define generic_move_ashuffle_l					MMoves[260]	
#define generic_move_staimdn_l					MMoves[261]	
#define generic_move_staim_l					MMoves[262]	
#define generic_move_attack_l					MMoves[263]
#define generic_move_chokekneesdeath			MMoves[264]
#define generic_move_electrocute_loop			MMoves[265]
#define generic_move_offladder_up				MMoves[266]
#define generic_move_pound_door					MMoves[267]	
#define generic_move_jumpstrup_jump				MMoves[268]	
#define generic_move_caim_l						MMoves[269]	
#define generic_move_crouch_rbk_mrs				MMoves[270]
#define generic_move_crouch_rbk_p				MMoves[271]
#define generic_move_bust_glass					MMoves[272]
#define generic_move_flip_table					MMoves[273]
#define generic_move_push_buttons				MMoves[274]
#define generic_move_push_crate					MMoves[275]
#define generic_move_signal_alarm				MMoves[276]
#define generic_move_typing						MMoves[277]
#define generic_move_wall2walk_mrs				MMoves[278]
#define generic_move_wall2walk_pk				MMoves[279]
#define generic_move_wallidle_mrs				MMoves[280]
#define generic_move_wallidle_pk				MMoves[281]
#define generic_move_walllook_lt_mrs			MMoves[282]
#define generic_move_walllook_lt_pk				MMoves[283]
#define generic_move_walllook_rt_mrs			MMoves[284]
#define generic_move_walllook_rt_pk				MMoves[285]
#define generic_move_wrenchh_frm				MMoves[286]
#define generic_move_wrenchh_n					MMoves[287]
#define generic_move_wrenchh_to					MMoves[288]
#define generic_move_wrenchv_frm				MMoves[289]
#define generic_move_wrenchv_n					MMoves[290]
#define generic_move_wrenchv_to					MMoves[291]
#define generic_move_come_here					MMoves[292]
#define generic_move_piss						MMoves[293]
#define generic_move_athreat_dwn				MMoves[294]
#define generic_move_athreat_fwd				MMoves[295]
#define generic_move_athreatyel_dwn				MMoves[296]
#define generic_move_athreatyel_fwd				MMoves[297]
#define generic_move_examine_wall				MMoves[298]
#define generic_move_backflip					MMoves[299]
#define generic_move_rageshoot					MMoves[300]
#define generic_move_sabremock					MMoves[301]
#define generic_move_runtostop					MMoves[302]
#define generic_move_talkboth					MMoves[303]
#define generic_move_gentalk					MMoves[304]
#define generic_move_headnod					MMoves[305]
#define generic_move_headshake					MMoves[306]
#define generic_move_jumprail					MMoves[307]
#define generic_move_walktostop					MMoves[308]
#define generic_move_spin180_lt					MMoves[309]
#define generic_move_spin180_rt					MMoves[310]
#define generic_move_idletorun					MMoves[311]
#define generic_move_leanrail					MMoves[312]
#define generic_move_talkright					MMoves[313]
#define generic_move_climbdown					MMoves[314]
#define generic_move_climbmid					MMoves[315]
#define generic_move_climbup					MMoves[316]
#define generic_move_dropgrenade				MMoves[317]
#define generic_move_falldeath					MMoves[318]
#define generic_move_fallimpact					MMoves[319]
#define generic_move_fromshadow					MMoves[320]
#define generic_move_fromshadow2				MMoves[321]
#define generic_move_handtalk					MMoves[322]
#define generic_move_handtalk2					MMoves[323]
#define generic_move_handtalk3					MMoves[324]
#define generic_move_handtalk4					MMoves[325]
#define generic_move_handtalk5					MMoves[326]
#define generic_move_headsettalk				MMoves[327]
#define generic_move_headsettalk2				MMoves[328]
#define generic_move_headsettalk3				MMoves[329]
#define generic_move_salute_begin				MMoves[330]
#define generic_move_saluting					MMoves[331]
#define generic_move_salute_end					MMoves[332]
#define generic_move_talkleft					MMoves[333]
#define generic_move_talklookleft				MMoves[334]
#define generic_move_talklookleft2				MMoves[335]
#define generic_move_talklookleft3				MMoves[336]
#define generic_move_talklookright				MMoves[337]
#define generic_move_talklookright2				MMoves[338]
#define generic_move_talklookright3				MMoves[339]
#define generic_move_idletorun2					MMoves[340]
#define generic_move_turnleft90					MMoves[341]
#define generic_move_turnright90				MMoves[342]
#define generic_move_idlegunup					MMoves[343]
#define generic_move_runonfire					MMoves[344]
#define generic_move_onfiretodeath				MMoves[345]
#define generic_move_runtostop2					MMoves[346]
#define generic_move_dropcrouch					MMoves[347]
#define generic_move_grenaderun					MMoves[348]
#define generic_move_femalewalk					MMoves[349]
#define generic_move_walkcarry					MMoves[350]
#define generic_move_walktalk					MMoves[351]
#define generic_move_a4scramble					MMoves[352]
#define generic_move_crouchnodleft				MMoves[353]
#define generic_move_crouchnodright				MMoves[354]
#define generic_move_crouchtalklt				MMoves[355]
#define generic_move_crouchtalkrt				MMoves[356]
#define generic_move_crouchready				MMoves[357]
#define generic_move_chokeshoot					MMoves[358]
#define generic_move_playerleanlt_to_a			MMoves[359]
#define generic_move_playerleanlt_to_l			MMoves[360]
#define generic_move_playerleanlt_mid_a			MMoves[361]
#define generic_move_playerleanlt_mid_l			MMoves[362]
#define generic_move_playerleanlt_frm_a			MMoves[363]
#define generic_move_playerleanlt_frm_l			MMoves[364]
#define generic_move_playerleanrt_to_a			MMoves[365]
#define generic_move_playerleanrt_to_l			MMoves[366]
#define generic_move_playerleanrt_mid_a			MMoves[367]
#define generic_move_playerleanrt_mid_l			MMoves[368]
#define generic_move_playerleanrt_frm_a			MMoves[369]
#define generic_move_playerleanrt_frm_l			MMoves[370]
#define generic_move_playerleanclt_to_a			MMoves[371]
#define generic_move_playerleanclt_to_l			MMoves[372]
#define generic_move_playerleanclt_mid_a		MMoves[373]
#define generic_move_playerleanclt_mid_l		MMoves[374]
#define generic_move_playerleanclt_frm_a		MMoves[375]
#define generic_move_playerleanclt_frm_l		MMoves[376]
#define generic_move_playerleancrt_to_a			MMoves[377]
#define generic_move_playerleancrt_to_l			MMoves[378]
#define generic_move_playerleancrt_mid_a		MMoves[379]
#define generic_move_playerleancrt_mid_l		MMoves[380]
#define generic_move_playerleancrt_frm_a		MMoves[381]
#define generic_move_playerleancrt_frm_l		MMoves[382]
#define generic_move_tostandfromtalk			MMoves[383]
#define generic_move_totalkfromstand			MMoves[384]
#define generic_move_butchswipe					MMoves[385]
#define generic_move_playerstrunswipe			MMoves[386]
#define generic_move_playercrunswipe			MMoves[387]
#define generic_move_runbeginjump				MMoves[388]
#define generic_move_threatenshoot				MMoves[389]
#define generic_move_staimdn_p					MMoves[390]	
#define generic_move_staimdn_mrs				MMoves[391]	
#define generic_move_cockshotgun				MMoves[397]	// 392 was just a copy of 397
#define generic_move_climbupoffladder			MMoves[393]
#define generic_move_dekkerstandfromcrouch		MMoves[394]
#define generic_move_ninjaidle					MMoves[395]
#define generic_move_handspringforward			MMoves[396]
#define generic_move_scock_s					MMoves[397]
#define generic_move_scock_r					MMoves[398]
#define generic_move_ccock_s					MMoves[399]
#define generic_move_armorblown					MMoves[400]
#define generic_move_upfromback					MMoves[401]
#define generic_move_crouch_launcher_runbk_aim	MMoves[402]
#define generic_move_crouch_knife_run_aim		MMoves[403]
#define generic_move_crouch_knife_runbk_aim		MMoves[404]
#define generic_move_gangsalute					MMoves[405]
#define generic_move_walkbackwards				MMoves[406]
#define generic_move_sabredeath					MMoves[407]
#define generic_move_stealthwalk				MMoves[408]
#define generic_move_jumpthrowstars				MMoves[409]
#define generic_move_proneidle					MMoves[410]
#define generic_move_yell						MMoves[411]
#define generic_move_alertlookright_mrs			MMoves[412]
#define generic_move_pushbuttonscene75			MMoves[413]
#define generic_move_coolerrun					MMoves[414]
#define generic_move_talkpose					MMoves[415]
#define generic_move_firerapidsweep				MMoves[416]
#define generic_move_alertturnleft				MMoves[417]
#define generic_move_surprise90left				MMoves[418]
#define generic_move_autosweepup				MMoves[419]
#define generic_move_wallidle					MMoves[420]
#define generic_move_wallidletalk				MMoves[421]
#define generic_move_idletoaim					MMoves[422]
#define generic_move_wallfear					MMoves[423]
#define generic_move_salute_begin_any			MMoves[424]
#define generic_move_saluting_any				MMoves[425]
#define generic_move_salute_end_any				MMoves[426]
#define generic_move_salutations				MMoves[427]
#define generic_move_climintoshaft				MMoves[428]
#define generic_move_crouchedwalk				MMoves[429]
#define generic_move_walktocrouch				MMoves[430]
#define generic_move_crouchtalkdown				MMoves[431]
#define generic_move_talkup						MMoves[432]
#define generic_move_crouchtalkposedown			MMoves[433]
#define generic_move_standtalkup				MMoves[434]
#define generic_move_crouchheadnod				MMoves[435]
#define generic_move_crouchtowalk				MMoves[436]
#define generic_move_walkfast					MMoves[437]
#define generic_move_erageidle					MMoves[438]
#define generic_move_talkpose_rt				MMoves[439]
#define generic_move_microwave_death			MMoves[440]
#define generic_move_look_at_book				MMoves[441]
#define generic_move_scan_book					MMoves[442]
#define generic_move_headsetfrom				MMoves[443]
#define generic_move_headsetlooping				MMoves[444]
#define generic_move_walkshotgun				MMoves[445]
#define generic_move_dekkeraim					MMoves[446]
#define generic_move_hawkknees					MMoves[447]
#define generic_move_dekkeraimtalk				MMoves[448]
#define generic_move_dekkerfirelook				MMoves[449]
#define generic_move_hawkdeath					MMoves[450]
#define generic_move_hawkkneeltalk				MMoves[451]
#define generic_move_hawkcrouch					MMoves[452]
#define generic_move_headsetto					MMoves[453]
#define generic_move_slideonback				MMoves[454]
#define generic_move_gunuplook					MMoves[455]
#define generic_move_firerapid					MMoves[456]
#define generic_move_dekkeraimlook				MMoves[457]
#define generic_move_playersignal_go			MMoves[458]
#define generic_move_playersignal_stop			MMoves[459]
#define generic_move_playersignal_taunt			MMoves[460]
#define generic_move_johnwhirlright				MMoves[461]
#define generic_move_sweepupfrom				MMoves[462]
#define generic_move_sweepupto					MMoves[463]
#define generic_move_takecover					MMoves[464]
#define generic_move_throwstar					MMoves[465]
#define generic_move_pain_larm_unhurt			MMoves[466]	
#define generic_move_pain_rarm_unhurt			MMoves[467]	
#define generic_move_pain_lleg_unhurt			MMoves[468]	
#define generic_move_pain_rleg_unhurt			MMoves[469]	
#define generic_move_jumpthrowstars_bk			MMoves[470]
#define generic_move_sabrebluff					MMoves[471]	
#define generic_move_sabreautosweep				MMoves[472]	
#define generic_move_throwknife					MMoves[473]	
#define generic_move_throwitem_player			MMoves[474]	
#define generic_move_caim_p_auto				MMoves[475]	
#define generic_move_staim_p_auto				MMoves[476]	
#define generic_move_handspringbackward			MMoves[477]
#define generic_move_falloutwindow				MMoves[478]
#define generic_move_crouchdwnpistol			MMoves[479]
#define generic_move_rollgrenade				MMoves[480]
#define generic_move_crouchdwnpistol1h			MMoves[481]
#define generic_move_walkfirefwd				MMoves[482]
#define generic_move_crouchfirefwd				MMoves[483]
#define generic_move_pushover					MMoves[484]
#define generic_move_reload_run_bk_p			MMoves[485]	
#define generic_move_reload_run_fwd_p			MMoves[486]	
#define generic_move_reload_run_lt_p			MMoves[487]	
#define generic_move_reload_run_rt_p			MMoves[488]	
#define generic_move_reload_run_bk_l			MMoves[489]	
#define generic_move_reload_run_fwd_l			MMoves[490]	
#define generic_move_reload_run_lt_l			MMoves[491]	
#define generic_move_reload_run_rt_l			MMoves[492]	
#define generic_move_reload_run_bk_ms			MMoves[493]	
#define generic_move_reload_run_fwd_ms			MMoves[494]	
#define generic_move_reload_run_lt_ms			MMoves[495]	
#define generic_move_reload_run_rt_ms			MMoves[496]	
#define generic_move_reload_run_bk_r			MMoves[497]	
#define generic_move_reload_run_fwd_r			MMoves[498]	
#define generic_move_reload_run_lt_r			MMoves[499]	
#define generic_move_reload_run_rt_r			MMoves[500]	
#define generic_move_reload_walk_bk_p			MMoves[501]	
#define generic_move_reload_walk_fwd_p			MMoves[502]	
#define generic_move_reload_walk_lt_p			MMoves[503]	
#define generic_move_reload_walk_rt_p			MMoves[504]	
#define generic_move_reload_walk_bk_l			MMoves[505]	
#define generic_move_reload_walk_fwd_l			MMoves[506]	
#define generic_move_reload_walk_lt_l			MMoves[507]	
#define generic_move_reload_walk_rt_l			MMoves[508]	
#define generic_move_reload_walk_bk_ms			MMoves[509]	
#define generic_move_reload_walk_fwd_ms			MMoves[510]	
#define generic_move_reload_walk_lt_ms			MMoves[511]	
#define generic_move_reload_walk_rt_ms			MMoves[512]	
#define generic_move_reload_walk_bk_r			MMoves[513]	
#define generic_move_reload_walk_fwd_r			MMoves[514]	
#define generic_move_reload_walk_lt_r			MMoves[515]	
#define generic_move_reload_walk_rt_r			MMoves[516]	
#define generic_move_reload_c_p					MMoves[517]	
#define generic_move_reload_c_l					MMoves[518]	
#define generic_move_reload_c_ms				MMoves[519]	
#define generic_move_reload_c_r					MMoves[520]	
#define generic_move_reload_crun_bk_p			MMoves[521]	
#define generic_move_reload_crun_fwd_p			MMoves[522]	
#define generic_move_reload_crun_bk_l			MMoves[523]	
#define generic_move_reload_crun_fwd_l			MMoves[524]	
#define generic_move_reload_crun_bk_ms			MMoves[525]	
#define generic_move_reload_crun_fwd_ms			MMoves[526]	
#define generic_move_reload_crun_bk_r			MMoves[527]	
#define generic_move_reload_crun_fwd_r			MMoves[528]	
#define generic_move_merchant_all				MMoves[529]	
#define generic_move_merchant_one				MMoves[530]	
#define generic_move_merchant_idle				MMoves[531]	
#define generic_move_merchant_wave_rt			MMoves[532]	
#define generic_move_merchant_talk				MMoves[533]	
#define generic_move_merchant_wave_lt			MMoves[534]	
#define generic_move_begging					MMoves[535]	
#define generic_move_crouchandcower				MMoves[536]
#define generic_move_fakedeath_lbshotdeath		MMoves[537]
#define generic_move_fakedeath_lfshotdeath		MMoves[538]


#define generic_dog_move_bark				MDogMoves[0]	// bark
#define generic_dog_move_pant				MDogMoves[1]	// pant
#define generic_dog_move_run				MDogMoves[2]	// run
#define generic_dog_move_deathside			MDogMoves[3]	// death
#define generic_dog_move_walk				MDogMoves[4]	// walk
#define generic_dog_move_walkleft			MDogMoves[5]	// walk left
#define generic_dog_move_attack				MDogMoves[6]	// attack
#define generic_dog_move_sniff				MDogMoves[7]	// sniff
#define generic_dog_move_attack2			MDogMoves[8]	// same as normal attack but starts several frames in
#define generic_dog_move_deathrun			MDogMoves[9]	// running death
#define generic_dog_move_sit				MDogMoves[10]	// just sittin' there
#define generic_dog_move_standup			MDogMoves[11]	// transition from sitting to standing (play it backwards)
#define generic_dog_move_sitdown			MDogMoves[12]	// transition from standing to sitting (just [11] forwards)
#define generic_dog_move_walk_from_sniff	MDogMoves[13]	// transition from sniff to walk
#define generic_dog_move_sniff_from_walk	MDogMoves[14]	// transition from walk to sniff
#define generic_dog_move_walk_from_walkl	MDogMoves[15]	// transition from walk (looking left) to walk (looking straight)
#define generic_dog_move_walkl				MDogMoves[16]	// walk (looking left)
#define generic_dog_move_walkl_from_walk	MDogMoves[17]	// transition from walk (looking straight) to walk (looking left)
#define generic_dog_move_walkl_walkr		MDogMoves[18]	// walk (looking left and right)
#define generic_dog_move_walk_from_walkr	MDogMoves[19]	// transition from walk (looking right) to walk (looking straight)
#define generic_dog_move_walkr				MDogMoves[20]	// walk (looking right)
#define generic_dog_move_walkr_from_walk	MDogMoves[21]	// transition from walk (looking straight) to walk (looking right)
#define generic_dog_move_death_lbshotdeath	MDogMoves[22]	// end of looping, shot-when-dead animation
#define generic_dog_move_death_lbshotloop	MDogMoves[23]	// looping, shot-when-dead animation
#define generic_dog_move_death_lbshotloop2	MDogMoves[24]	// looping, shot-when-dead animation
#define generic_dog_move_death_back			MDogMoves[25]	// blown backward death


#define generic_cow_move_idle				MCowMoves[0]
#define generic_cow_move_walk				MCowMoves[1]
#define generic_cow_move_die_right			MCowMoves[2]
#define generic_cow_move_moo				MCowMoves[3]
#define generic_cow_move_looking			MCowMoves[4]
#define generic_cow_move_pain				MCowMoves[5]
				